package com.unipi.talepis;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Main {

    public static void main(String[] args) {
        List<String> strings = Arrays.asList("student1","student2",
                "human1","professor2","professor3");
        /*strings
                .stream()
                .filter(s -> s.startsWith("s"))
                .map(String::toUpperCase)
                .sorted()
                .forEach(System.out::println);*/
        /*Arrays.asList("a","b","c")
                .stream()
                .findFirst()
                .ifPresent(System.out::println);*/
        /*Stream.of("b","c","k").findFirst().ifPresent(System.out::println);*/
        //IntStream.range(1,11).forEach(System.out::println);
        /*Stream.of("n2","k5","d4","u7")
                .map(s -> s.substring(1))
                .mapToInt(Integer::parseInt)
                .max()
                .ifPresent(System.out::println);*/
        /*IntStream.range(2,8)
                .mapToObj(n -> "Str"+n)
                .forEach(System.out::println);*/
        /*Stream.of("student1","student2",
                "human1","professor2","professor3")
                .map(s -> {
                    System.out.println("map:"+s);
                    return s.toUpperCase();
                })
                .filter(s -> {
                    System.out.println("filter:"+s);
                    return s.startsWith("P");
                })
                .forEach(s -> System.out.println("forEach:"+s));
        System.out.println("----------------------------------------");
        Stream.of("student1","student2",
                "human1","professor2","professor3")
                .filter(s -> {
                    System.out.println("filter:"+s);
                    return s.startsWith("p");
                })
                .map(s -> {
                    System.out.println("map:"+s);
                    return s.toUpperCase();
                })
                .forEach(s -> System.out.println("forEach:"+s));
        System.out.println("------------------------------------");
        Stream.of("student1","student2",
                "human1","professor2","professor3")
                .sorted((s1,s2)->{
                    System.out.println("sort:"+s1+","+s2);
                    return s1.compareTo(s2);
                })
                .filter(s -> {
                    System.out.println("filter:"+s);
                    return s.startsWith("p");
                })
                .map(s -> {
                    System.out.println("map:"+s);
                    return s.toUpperCase();
                })
                .forEach(s -> System.out.println("forEach:"+s));*/
        Stream<String> stringStream =
                Stream.of("student1","student2",
                        "human1","professor2","professor3");
        stringStream.anyMatch(s -> true);
        //stringStream.noneMatch(s -> true);//throws exception

        /*Supplier<Stream<String>> streamSupplier =
                () -> Stream.of("student1","student2",
                        "human1","professor2","professor3")
                        .filter(s -> s.startsWith("s"));
        streamSupplier.get().anyMatch(s -> true);
        streamSupplier.get().noneMatch(s -> true);*/
        List<Student> studentList =
                Arrays.asList(
                        new Student("Marios",5),
                        new Student("Christina",9),
                        new Student("Manolis",4),
                        new Student("Costas",4),
                        new Student("Babis",4),
                        new Student("Petros",9)
                );
        List<Student> pernane =
                studentList
                .stream()
                .filter(student -> student.grade>4)
                .collect(Collectors.toList());
        System.out.println(pernane);
        Map<Integer,List<Student>> studentsByGrade =
                studentList.stream()
                .collect(Collectors.groupingBy(student -> student.grade));
        System.out.println(studentsByGrade);
    }
}
